package cn.com.tenlion.systembase.service.homicidesuspect;

import cn.com.tenlion.systembase.pojo.bos.homicidesuspect.HomicideSuspectBO;
import cn.com.tenlion.systembase.pojo.dtos.homicidesuspect.HomicideSuspectDTO;
import cn.com.tenlion.systembase.pojo.pos.homicidesuspect.HomicideSuspectPO;
import cn.com.tenlion.systembase.pojo.vos.homicidesuspect.HomicideSuspectVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IHomicideSuspectService
 * @Description: 命案犯罪嫌疑人
 * @Author: CodeFactory
 * @Date: 2021-10-19 10:59:12
 * @Version: 3.0
 **/
public interface IHomicideSuspectService {

    /**
     * 新增命案犯罪嫌疑人
     *
     * @param homicideSuspectVO
     * @return
     */
    void save(HomicideSuspectVO homicideSuspectVO);

    /**
     * 新增命案犯罪嫌疑人
     *
     * @param token
     * @param homicideSuspectVO
     * @return
     */
    void save(String token, HomicideSuspectVO homicideSuspectVO);

    /**
     * 新增命案犯罪嫌疑人
     *
     * @param homicideSuspectVO
     * @return homicideSuspectId
     */
    String saveReturnId(HomicideSuspectVO homicideSuspectVO);

    /**
     * 新增命案犯罪嫌疑人
     *
     * @param token
     * @param homicideSuspectVO
     * @return homicideSuspectId
     */
    String saveReturnId(String token, HomicideSuspectVO homicideSuspectVO);

    /**
     * 删除命案犯罪嫌疑人
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除命案犯罪嫌疑人
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除命案犯罪嫌疑人（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改命案犯罪嫌疑人
     *
     * @param homicideSuspectId
     * @param homicideSuspectVO
     * @return
     */
    void update(String homicideSuspectId, HomicideSuspectVO homicideSuspectVO);

    /**
     * 修改命案犯罪嫌疑人
     *
     * @param token
     * @param homicideSuspectId
     * @param homicideSuspectVO
     * @return
     */
    void update(String token, String homicideSuspectId, HomicideSuspectVO homicideSuspectVO);

    /**
     * 命案犯罪嫌疑人详情
     *
     * @param params 参数Map
     * @return
     */
    HomicideSuspectDTO get(Map<String, Object> params);

    /**
     * 命案犯罪嫌疑人详情
     *
     * @param homicideSuspectId
     * @return
     */
    HomicideSuspectDTO get(String homicideSuspectId);

    /**
     * 命案犯罪嫌疑人详情
     *
     * @param params 参数Map
     * @return
     */
    HomicideSuspectBO getBO(Map<String, Object> params);

    /**
     * 命案犯罪嫌疑人详情
     *
     * @param homicideSuspectId
     * @return
     */
    HomicideSuspectBO getBO(String homicideSuspectId);

    /**
     * 命案犯罪嫌疑人详情
     *
     * @param params 参数Map
     * @return
     */
    HomicideSuspectPO getPO(Map<String, Object> params);

    /**
     * 命案犯罪嫌疑人详情
     *
     * @param homicideSuspectId
     * @return
     */
    HomicideSuspectPO getPO(String homicideSuspectId);

    /**
     * 命案犯罪嫌疑人列表
     *
     * @param params
     * @return
     */
    List<HomicideSuspectDTO> list(Map<String, Object> params);

    /**
     * 命案犯罪嫌疑人列表
     *
     * @param params
     * @return
     */
    List<HomicideSuspectBO> listBO(Map<String, Object> params);

    /**
     * 命案犯罪嫌疑人列表
     *
     * @param params
     * @return
     */
    List<HomicideSuspectPO> listPO(Map<String, Object> params);

    /**
     * 命案犯罪嫌疑人分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<HomicideSuspectDTO>> listPage(ListPage page);

    /**
     * 命案犯罪嫌疑人统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}